require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"

layout = {
  GridView,
  id = "grid",
  numColumns = 2,
  layout_width = "fill",
  layout_height = "fill"
}

items = {
  "إنشاء رابط لحساب telegram",
  "إنشاء رابط لحساب WhatsApp",
  "أحوال الطقس",
  "نسخ رابط التطبيق المفتوح إلى الحافظة",
  "مولد كلمات المرور",
  "القرعة العشوائية",
}

dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))
dlg.setTitle("Tools Space")
dlg.setButton("خروج", nil)
dlg.show()

grid.onItemClick = function(l, v)
  dlg.dismiss()
  task(500, function()
    if v.text == "إنشاء رابط لحساب telegram" then 
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "أدخل اسم المستخدم بدون @";
          id = "edit";
        };
        {
          Button;
          text = "مراسلة الحساب";
          onClick = function()
            if edit.text == "" then
              service.speak("قم بإدخال اسم المستخدم أولا")
            else
              this.startActivity(Intent(Intent.ACTION_VIEW,
                Uri.parse("https://t.me/"..edit.text)))
              service.click({{"%العودة"}})
              service.playSoundTick()
              service.postClick(2000, {{"dlg.dismiss()"}})            
            end
          end
        };
        {
          Button;
          text = "إنشاء رابط ونسخه";
          onClick = function()
            if edit.text == "" then
              service.speak("قم بإدخال اسم المستخدم أولا")
            else
              service.copy("https://t.me/"..edit.text)
              service.postSpeak(100, "تم إنشاء الرابط ونسخه إلى الحافظة")
            end
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end
        };
      }
      dlg = LuaDialog(this)
      dlg.setTitle("إنشاء رابط لحساب Telegram")
      dlg.setView(loadlayout(InputLayout))
      dlg.show()
    elseif v.text == "إنشاء رابط لحساب WhatsApp" then
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "مثال: 966500123456";
          id = "edit";
          layout_marginLeft = "16dp";
          layout_marginRight = "16dp";
        };
        {
          Button;
          text = "مراسلة الحساب";
          onClick = function()
            if edit.text == "" then
              service.speak("قم بإدخال رقم الهاتف أولا")
            else
              local phoneNumber = edit.text
              local whatsappUrl = "https://wa.me/" .. phoneNumber
              this.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse(whatsappUrl)))
              service.click({{"%العودة"}})
              service.playSoundTick()
              service.postClick(2000, {{"dlg.dismiss()"}})
            end
          end
        };
        {
          Button;
          text = "إنشاء رابط ونسخه";
          onClick = function()
            if edit.text == "" then
              service.speak("قم بإدخال رقم الهاتف أولا")
            else
              local phoneNumber = edit.text
              local whatsappUrl = "https://wa.me/" .. phoneNumber
              service.copy(whatsappUrl)
              service.postSpeak(100, "تم إنشاء الرابط ونسخه إلى الحافظة")
            end
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end
        };
      }
      dlg = LuaDialog(this)
      dlg.setTitle("إنشاء رابط لحساب WhatsApp")
      dlg.setView(loadlayout(InputLayout))
      dlg.show()
    elseif v.text == "أحوال الطقس" then
      import "android.content.*"
      intent = Intent(Intent.ACTION_MAIN)
      intent.setComponent(ComponentName(
        "com.google.android.googlequicksearchbox",
        "com.google.android.apps.search.weather.WeatherExportedActivity"
      ))
      this.startActivity(intent)
      service.asyncSpeak("يتم عرض أحوال الطقس.")
      return true
    elseif v.text == "نسخ رابط التطبيق المفتوح إلى الحافظة" then
      local appName = this.getAppName(node)
      local appPackage = node.getPackageName()
      local appUrl = 'https://play.google.com/store/apps/details?id=' .. appPackage
      service.copy('رابط تطبيق\n' .. appName .. '\n' .. appUrl)
      service.postSpeak(300, 'تم نسخ رابط تطبيق ' .. appName .. ' إلى الحافظة')
      dlg.dismiss()
    elseif v.text == "مولد كلمات المرور" then
      passwordGeneratorLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          TextView;
          text = "طول كلمة المرور:";
        };
        {
          EditText;
          hint = "أدخل طول كلمة المرور";
          id = "passwordLengthEdit";
        };
        {
          CheckBox;
          text = "تضمين أحرف كبيرة";
          id = "includeUppercaseCheckbox";
        };
        {
          CheckBox;
          text = "تضمين أحرف صغيرة";
          id = "includeLowercaseCheckbox";
        };
        {
          CheckBox;
          text = "تضمين أرقام";
          id = "includeNumbersCheckbox";
        };
        {CheckBox;
          text = "تضمين الرموز";
          id = "includeSpecialCharsCheckbox";
        };
        {
          CheckBox;
          text = "نسخ كلمة المرور تلقائيًا";
          id = "copyPasswordCheckbox";
        };
        {
          Button;
          text = "إنشاء كلمة المرور";
          onClick = function()
            local passwordLength = tonumber(passwordLengthEdit.text)
            local includeUppercase = includeUppercaseCheckbox.isChecked()
            local includeLowercase = includeLowercaseCheckbox.isChecked()
            local includeNumbers = includeNumbersCheckbox.isChecked()
            local includeSpecialChars = includeSpecialCharsCheckbox.isChecked()
            local copyPassword = copyPasswordCheckbox.isChecked()

            if passwordLength then
              local chars = ""
              if includeUppercase then
                chars = chars .. "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
              end
              if includeLowercase then
                chars = chars .. "abcdefghijklmnopqrstuvwxyz"
              end
              if includeNumbers then
                chars = chars .. "0123456789"
              end
              if includeSpecialChars then
                chars = chars .. "!@#$%^&*()_+[]{}|;:,.<>?~"
              end

              if chars == "" then
                service.speak("يرجى تحديد خيار واحد على الأقل")
              else
                local password = ""
                for i = 1, passwordLength do
                  local randomIndex = math.random(1, #chars)
                  password = password .. chars:sub(randomIndex, randomIndex)
                end
                print("كلمة المرور العشوائية:", password)
                if copyPassword then
                  service.copy(password)
                end
              end
            else
              service.speak("يرجى إدخال طول كلمة المرور")
            end
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      }

      dlg = LuaDialog(this)
      dlg.setTitle("مولد كلمات المرور")
      dlg.setView(loadlayout(passwordGeneratorLayout))
      dlg.show()
    elseif v.text == "القرعة العشوائية" then
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "أدخل الأسماء (مفصولة بفواصل)";
          id = "valuesEdit";
        };
        {
          Button;
          text = "سحب";
          onClick = function()
            local values = valuesEdit.text
            local valueList = {}
            for value in string.gmatch(values, "[^,%s]+") do
              table.insert(valueList, value)
            end
            local randomIndex = math.random(1, #valueList)
            local randomValue = valueList[randomIndex]
            service.speak("الفائز هو: " .. randomValue)
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      }

      dlg = LuaDialog()
      dlg.setTitle("القرعة العشوائية")
      dlg.setView(loadlayout(InputLayout))
      dlg.show()
    end
  end)
end